#include "gestioneVoli.h"

Volo* leggiVoli(char fileName[], int *dim){
	int count,i;
	FILE * fp;
	Volo* result;
	Volo temp;

	if((fp=fopen(fileName,"r"))==NULL)
		exit(1);
	count = 0;
	while (fscanf(fp,"%s %s %s %d %f",
				temp.codiceVolo,temp.cittaPartenza,temp.cittaArrivo,
				&(temp.durata),&(temp.costo))==5)
		count++;
	rewind(fp);

	result = (Volo *) malloc (count * sizeof(Volo));
	for(i=0;i<count;i++)
			fscanf(fp,"%s %s %s %d %f",
				result[i].codiceVolo,result[i].cittaPartenza,result[i].cittaArrivo,
				&(result[i].durata),&(result[i].costo));
	fclose(fp);
	*dim=count;
	return result;
}

void stampaVolo(Volo v){
	printf("\nVolo - Codice Volo: %s\t Codice Partenza: %s\t Codice Arrivo: %s\t Durata: %d\t Costo: %f", v.codiceVolo, v.cittaPartenza, v.cittaArrivo, v.durata, v.costo);
}
Prenotazione* leggiPrenotazioni(char fileName[], int *dim){
	int count,i;
	FILE * fp;
	Prenotazione* result;
	Prenotazione temp;

	if((fp=fopen(fileName,"r"))==NULL)
		exit(1);
	count = 0;
	while (fscanf(fp,"%s %s %c %d %f",
				temp.codiceVolo,temp.nomeCliente,&(temp.tipo),
				&(temp.numeroBiglietti),&(temp.costoTotale))==5)
		count++;
	rewind(fp);

	result = (Prenotazione *) malloc (count * sizeof(Prenotazione));
	for(i=0;i<count;i++)
			fscanf(fp,"%s %s %c %d %f",
				result[i].codiceVolo,result[i].nomeCliente,&(result[i].tipo),
				&(result[i].numeroBiglietti),&(result[i].costoTotale));
	fclose(fp);
	*dim=count;
	return result;
}

void stampaPrenotazione(Prenotazione p){
	printf("\nPrenotazione - Codice Volo: %s\t Nome Cliente: %s\t Tipo: %c\t Numero Biglietti: %d\t Costo Totale: %f", p.codiceVolo, p.nomeCliente, p.tipo, p.numeroBiglietti, p.costoTotale);
}

int inserisciPrenotazione(FILE* fp,Prenotazione *p, int dimP, Volo* v, int dimV){	
	char voloDaInserire[dimCodiceVolo], nomeCliente[dimNome];
	char cittaArrivo[dimCodiceCitta];
	char cittaPartenza[dimCodiceCitta];
	char tipo;
	int i,trattaEsiste=0,numero;
	float prezzoBase,costoTotale;

	printf("\nInserimento nuova prenotazione");
	printf("\nNome Cliente?\t");
	scanf("%s",nomeCliente);
	printf("%s",nomeCliente);
	printf("\nCitta partenza?\t");
	scanf("%s",cittaPartenza);
	printf("\nCitta arrivo?\t");
	scanf("%s",cittaArrivo);
	printf("\nTipo biglietto?");
	scanf("%*c");  //consuma caratteri spuri rimasti nel buffer di inserimento
	scanf("%c",&tipo);
	printf("\nNumero biglietti?");
	scanf("%d",&numero);
	if(tipo!='A' && tipo!='R'){
		printf("Tipo biglietto non valido");
		return -1;
	}
	for(i=0;i<dimV;i++){
		if((!strcmp(cittaPartenza,v[i].cittaPartenza))||(!strcmp(cittaArrivo,v[i].cittaArrivo)) &&
				(!strcmp(cittaPartenza,v[i].cittaPartenza))||(!strcmp(cittaPartenza,v[i].cittaArrivo))){
			trattaEsiste=1;
			prezzoBase=v[i].costo;
			strcpy(voloDaInserire,v[i].codiceVolo);
		}
	}
	if(!trattaEsiste)
		return -1;
        if(tipo=='A')
		costoTotale=numero*prezzoBase;
	if(tipo=='R')
		costoTotale=numero*(prezzoBase+prezzoBase*1.6);
	fprintf(fp,"%s %s %c %d %f\n",voloDaInserire,nomeCliente,tipo,numero,costoTotale);

	return 0;
}

Volo* trovaVoli(char* citta, Volo* v, int dimV, int* dimResult){
	int i,j,k;
	Volo *voliTrovati;
        for(i=0;i<dimV;i++)
		if(!strcmp(citta,v[i].cittaArrivo)||!strcmp(citta,v[i].cittaPartenza))
			(*dimResult)++;
	voliTrovati = (Volo *) malloc (*dimResult * sizeof(Volo));
	//insert sort
	j=0;
	for(i=0;i<dimV;i++){
		if(!strcmp(citta,v[i].cittaArrivo)||!strcmp(citta,v[i].cittaPartenza)){
			k=j-1;
			while(k>=0 && v[i].costo<voliTrovati[k].costo){
				voliTrovati[k+1]=voliTrovati[k];
				k--;
			}
			voliTrovati[k+1]=v[i];
			j++;
		}
	}
	return voliTrovati;
}
